class Tablets.Tablet
  constructor: (@element, options = {}) ->
    @initVars()
    @initHandlers()
    @datatableOptions = options.datatableOptions
    @params = options.params
    initializeInstantly = options.initializeInstantly

    Tablets.set(@id, this)

    if initializeInstantly
      @initTable()
    else if Turbolinks && Turbolinks.supported
      $(document).one 'turbolinks:load', =>
        @initTable()
    else
      $ =>
        @initTable()

  dataTableOptions: ->
    $.extend {}, @datatableOptions,
      fnServerParams: (data) =>
        data.params = @serverParams()
      fnRowCallback: (row, data) =>
        $(row).addClass('has-details') if data.details

  serverParams: ->
    params = $.extend({}, @params)

    @trigger('beforeRequest', params)

    params

  initVars: ->
    @id = @element.attr('id')
    @name = @element.attr('data-name')

  initTable: ->
    options = @dataTableOptions()

    @trigger('beforeInit', options)

    @table = $(@element).DataTable(options)

    @trigger('afterInit')

  initHandlers: ->
    @element.on 'xhr.dt', (_event, _table, data) =>
      @trigger('afterResponse', data)

  reload: ->
    @element.dataTable().fnDraw()

  toggleDetails: (tr) ->
    row = @table.row tr

    if row.child.isShown()
      row.child.hide()
      tr.removeClass 'expanded'
      tr.removeClass 'shown'
    else
      data = row.data().details
      row.child("<span>#{data}</span>").show()
      tr.addClass 'expanded'
      tr.addClass 'shown'

  trigger: (event, params...) ->
    Tablets.trigger(event, this, params)
