module Tablets
  # Responsible to provide data to tablet on ajax request
  class AjaxController < ApplicationController
    before_action :authorize!

    def data
      render json: Tablets::Data.new(tablet, data_params, self)
    end

    private

    def tablet
      @tablet ||= Tablets[params[:name].to_s].new
    end

    def authorize!
      render nothing: true, status: 401 unless authorized?
    end

    def authorized?
      tablet.authorize(self)
    rescue
      false
    end

    def data_params
      params.slice(:name, :start, :length, :search,
                   :order, :params, :draw, :columns)
    end
  end
end
