module Tablets
  module Global
    # Tablets loader
    # Manages files loading from app tablets directory
    module Loader
      # Loads tablets files
      def load!
        files.each { |file| load file }
      end

      private

      # Load paths
      def load_paths
        [Tablets.tablets_dir]
      end

      # Prepares files list using load paths
      def files
        load_paths.flatten.compact.uniq.flat_map do |path|
          Dir["#{path}/**/*.rb"]
        end
      end
    end
  end
end
