require 'tablets/renderer'

module Tablets
  # View helpers included to Rails
  module ViewHelpers
    # Finds tablet by name and renders is with params in current view context
    #
    #  <%= render_tablet :posts, user_id: @user.id %>
    #
    #  initialize_instantly option skips waiting for page:change event and initializes tablet instantly
    def render_tablet(name, opts = {})
      locals = opts.fetch(:locals, {})
      initialize_instantly = opts.fetch(:initialize_instantly, false)

      Tablets::Renderer.new(Tablets[name.to_s].new, locals, initialize_instantly: initialize_instantly).render(self)
    end
  end
end
